{Just a note about my source code.  It ain't pretty, but does the job (usually) I am making it available not
so much for people to remake the binary clock (which you can) but rather to utuilize the smaller examples
within to do things like make tranparent backgrounds, etc.}

unit BinaryClock1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Math, Registry;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Timer1: TTimer;
    Timer2: TTimer;
    Image2: TImage;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawRoundRectRegion(wnd : HWND; wrect : TRect);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SwitchLights(SL1,SL2 : integer);
    procedure SwitchPM;
    procedure MapBackGround;
    procedure RepaintForm;
  private
    { Private declarations }
     rgn  : HRGN;              {These are needed for the DrawRectRegion stuff}
     wrect : TRect;
     LbDown : boolean;
  public
    { Public declarations }
  end;

var
  Form1                                  : TForm1;
  IntMe,PadY,IWide,IHigh,CHigh,CWide     : longint;
  Blink,Moveable,UpperDisplay,Colons     : boolean;
  Seconds,PmLite,FTime                   : boolean;
  NewStr,OldStr,DiffStr,S1,S2,PicStr     : string;
  OldBStr,BStr,OldPM,TempStr5            : string;
  TempStr1,TempStr2,TempStr3,TempStr4    : string;
  I,J,Int1,FH,Pad,K,LedSize              : integer;
  ImageOn                                : array [0..4,0..3] of Boolean;  {LED Lights array}
  DC                                     : HDc;
  Canv                                   : TCanvas;
  LedOnIn, LedOnOut, LedOffIn, LedOffOut : TColor;
  CR1,CB1,CG1,CR2,CB2,CG2,PMWide         : integer;
  DR1,DB1,DG1,DR2,DB2,DG2,Back,FirstTime : integer;
  DriveStr,DirectoryStr,TopPos           : string;

implementation

uses BinaryClock2, BinaryClock3;

{$R *.DFM}

procedure TForm1.MapBackGround;   {Copy the desktop background onto the TImage canvas...}
begin
   DC          := GetWindowDC( GetDeskTopWindow );
   Canv        := TCanvas.Create;
   Canv.Handle := DC;
   BitBlt(Form1.Image1.Canvas.handle,0,0,Form1.Image1.Width,Form1.Image1.Height,DC,Form1.Left,Form1.Top+PadY,SRCCOPY);
   ReleaseDC( GetDeskTopWindow, DC );
end;

function LoadStringFromRegistry(sKey, sItem, sDefVal : string): string;  {Read from the registry}
var
  reg : TRegIniFile;
begin
  reg := TRegIniFile.Create( sKey );
  Result := reg.ReadString('', sItem, sDefVal);
  reg.Free;
end;

procedure SaveStringToRegistry(sKey, sItem, sVal : string );      {Write to the registry}
var
  reg : TRegIniFile;
begin
  reg := TRegIniFile.Create( sKey );
  reg.WriteString('', sItem, sVal + #0);
  reg.Free;
end;

procedure TForm1.DrawRoundRectRegion(wnd : HWND; wrect : TRect);  {Draw the form as a rounded rectangle}
begin
  rgn := CreateRoundRectRgn(wrect.left, wrect.top, wrect.right, wrect.bottom, (LEDSize), (LEDSize));
  SetWindowRgn(wnd, rgn, TRUE);
end;

procedure TForm1.RepaintForm;  {Repaint all the various items in the form (image, leds, etc.)}
begin
   Form1.Visible:=false;
   Form1.Image1.Invalidate;
   if (Back=2) then MapBackground;
   If ((Back=1)and (PicStr<>'')) then
      begin
         try Image1.Picture.LoadFromFile(PicStr);
         except
            on EInvalidGraphic do
               begin
                  ShowMessage('Invalid graphic name.');
               end;
            on EFOpenError do
               begin
                  ShowMessage('Could not open the graphic file requested.');
               end;
         end;
      end;
   ClientHeight:=Round((LEDSize*4.5));
   ClientWidth :=Round((LEDSize*8.5));
   if (UpperDisplay) then ClientHeight:=ClientHeight+17;
   if (not(Seconds) and not(PMLite)) then
      begin
         ClientWidth:=Round(LEDSize*4.5);
         Image1.Width:=ClientWidth;
      end
   else
   if (not(Seconds) and (PMLite)) then
      begin
         ClientWidth:=Round(LEDSize*6.5);
         Image1.Width:=ClientWidth;
      end
   else
   if ((Seconds) and Not(PMLite)) then
      begin
         ClientWidth:=Round(LEDSize*7);
         Image1.Width:=ClientWidth;
      end;
   SetWindowPos(Form1.Handle,HWND_BOTTOM,Form1.Left,Form1.Top,Form1.Width,Form1.Height,SWP_NOMOVE);
   DrawRoundRectRegion(Form1.Handle, Form1.ClientRect);
   Image1.Height:=ClientHeight;
   Image1.Width:=ClientWidth;
   For I := 0 to 4 do
     For J := 0 to 3 do
        begin
           SwitchLights(I,J);
           SwitchLights(I,J);
        end;
   SwitchPM;
   SwitchPM;

   if (PMLite) then
      begin
         Image1.Canvas.Font.Color:=$0000FF80;
         Image1.Canvas.Font.Name:='Unknown';
         Image1.Canvas.Font.Size:=LEDSize div 3;
         Image1.Canvas.Brush.Color := clBlack;
         PMWide:=Image1.Canvas.TextWidth('PM');
         if (Seconds) then Image1.Canvas.TextOut((((6*LEDSize)+1+LEDSize)+trunc((LEDSize-PMWide) div 2))-1,2*LEDSize+1,'PM')
         else Image1.Canvas.TextOut((((round(3.5*LEDSize))+1+LEDSize)+trunc((LEDSize-PMWide) div 2))-1,2*LEDSize+1,'PM');
      end;
   Form1.Visible:=true;
end;

procedure TForm1.SwitchLights(SL1,SL2 : integer);   {This routine switches the LEDS on or off. It is a     }
                                                    {major pain since I opted not to use matrix multiplying}
                                                    {but did trial and error using the LED size to determine}
                                                    {the location of the leds.}
begin
   If (ImageOn[Sl1,SL2]=false) then
       begin
          case SL1 of
             0   : Pad:=(LEDSize div 2);
             1,2 : Pad:=LEDSize;
             3,4 : Pad:=LEDSize + (LEDSize div 2);
          end;
          ImageOn[SL1,SL2]:=true;
          Form1.Image1.Canvas.Pen.Color:=LedOnOut;
          Form1.Image1.Canvas.Brush.Color:=LedOnOut;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Canvas.Ellipse((SL1*LEDSize)+1+Pad,SL2*LEDSize+1,(SL1*LEDSize)+LEDSize+Pad,(SL2*LEDSize)+LEDSize);
          Form1.Image1.Canvas.Pen.Color:=LedOnIn;
          Form1.Image1.Canvas.Brush.Color:=LedOnIn;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Canvas.Ellipse((SL1*LEDSize)+((LEDSize div 8)+1)+Pad,SL2*LEDSize+((LEDSize div 8)+1),(SL1*LEDSize)+(LEDSize-(LEDSize div 8))+Pad,(SL2*LEDSize)+(LEDSize-(LEDSize div 8)));
          Form1.Image1.Canvas.Pen.Color:=clWhite;
          Form1.Image1.Canvas.Brush.Color:=clWhite;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Canvas.Ellipse((SL1*LEDSize)+((LEDSize div 3))+Pad,SL2*LEDSize+((LEDSize div 3)),(SL1*LEDSize)+((LEDSize div 3))+Pad+(LEDSize div 5),(SL2*LEDSize)+((LEDSize div 3))+(LEDSize div 5));
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Repaint;
       end
   else
       begin
          case SL1 of
             0   : Pad:=(LEDSize div 2);
             1,2 : Pad:=LEDSize;
             3,4 : Pad:=LEDSize + (LEDSize div 2);
          end;
          ImageOn[SL1,SL2]:=false;
          Form1.Image1.Canvas.Pen.Color:=LedOffOut;
          Form1.Image1.Canvas.Brush.Color:=LedOffOut;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Canvas.Ellipse((SL1*LEDSize)+1+Pad,SL2*LEDSize+1,(SL1*LEDSize)+LEDSize+Pad,(SL2*LEDSize)+LEDSize);
          Form1.Image1.Canvas.Pen.Color:=LedOffIn;
          Form1.Image1.Canvas.Brush.Color:=LedOffIn;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Canvas.Ellipse((SL1*LEDSize)+((LEDSize div 8)+1)+Pad,SL2*LEDSize+((LEDSize div 8)+1),(SL1*LEDSize)+(LEDSize-(LEDSize div 8))+Pad,(SL2*LEDSize)+(LEDSize-(LEDSize div 8)));
          Form1.Image1.Canvas.Pen.Color:=clSilver;
          Form1.Image1.Canvas.Brush.Color:=clSilver;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Canvas.Ellipse((SL1*LEDSize)+((LEDSize div 3))+Pad,SL2*LEDSize+((LEDSize div 3)),(SL1*LEDSize)+((LEDSize div 3))+Pad+(LEDSize div 5),(SL2*LEDSize)+((LEDSize div 3))+(LEDSize div 5));
          if ((SL1<3) or ((SL1>2) and (Seconds))) then Form1.Image1.Repaint;
       end;
end;

procedure TForm1.SwitchPM;  {Seperate routine for the PM led}
var
   YPad  : integer;
   XPad  : real;
begin
   If (Seconds) then XPad:=6
   else XPad:=3.5;
   YPad:=1;
   Pad:=(LEDSize);
   If ((PMLite) and (OldPM='AM')) then
       begin
          OldPM:='PM';
          Form1.Image1.Canvas.Pen.Color:=LEDOnOut;
          Form1.Image1.Canvas.Brush.Color:=LEDOnOut;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          Form1.Image1.Canvas.Ellipse((round(XPad*LEDSize))+1+Pad,YPad*LEDSize+1,(round(XPad*LEDSize))+LEDSize+Pad,(YPad*LEDSize)+LEDSize);
          Form1.Image1.Canvas.Pen.Color:=LEDOnIn;
          Form1.Image1.Canvas.Brush.Color:=LEDOnIn;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          Form1.Image1.Canvas.Ellipse((round(XPad*LEDSize))+((LEDSize div 8)+1)+Pad,YPad*LEDSize+((LEDSize div 8)+1),(round(XPad*LEDSize))+(LEDSize-(LEDSize div 8))+Pad,(YPad*LEDSize)+(LEDSize-(LEDSize div 8)));
          Form1.Image1.Canvas.Pen.Color:=clWhite;
          Form1.Image1.Canvas.Brush.Color:=clWhite;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          Form1.Image1.Canvas.Ellipse((round(XPad*LEDSize))+((LEDSize div 3))+Pad,YPad*LEDSize+((LEDSize div 3)),(round(XPad*LEDSize))+((LEDSize div 3))+Pad+(LEDSize div 5),(YPad*LEDSize)+((LEDSize div 3))+(LEDSize div 5));
          Form1.Image1.Repaint;
       end
   else
   if (PMLite) then
       begin
          OldPM:='AM';
          Form1.Image1.Canvas.Pen.Color:=LEDOffOut;
          Form1.Image1.Canvas.Brush.Color:=LEDOffOut;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          Form1.Image1.Canvas.Ellipse((round(XPad*LEDSize))+1+Pad,YPad*LEDSize+1,(round(XPad*LEDSize))+LEDSize+Pad,(YPad*LEDSize)+LEDSize);
          Form1.Image1.Canvas.Pen.Color:=LEDOffIn;
          Form1.Image1.Canvas.Brush.Color:=LEDOffIn;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          Form1.Image1.Canvas.Ellipse((round(XPad*LEDSize))+((LEDSize div 8)+1)+Pad,YPad*LEDSize+((LEDSize div 8)+1),(round(XPad*LEDSize))+(LEDSize-(LEDSize div 8))+Pad,(YPad*LEDSize)+(LEDSize-(LEDSize div 8)));
          Form1.Image1.Canvas.Pen.Color:=clSilver;
          Form1.Image1.Canvas.Brush.Color:=clSilver;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          Form1.Image1.Canvas.Ellipse((round(XPad*LEDSize))+((LEDSize div 3))+Pad,YPad*LEDSize+((LEDSize div 3)),(round(XPad*LEDSize))+((LEDSize div 3))+Pad+(LEDSize div 5),(YPad*LEDSize)+((LEDSize div 3))+(LEDSize div 5));
          Form1.Image1.Repaint;
       end;
end;


function BinStr(value : LongInt) : string;  {This function converts an integer into a binary string}
var
   T1,T2 : extended;
   Str1  : string;
begin
   Str1:='';
   T2:=value;
   For I:= 31 downto 0 do
      begin
         T1:=power(2,I);
         if ((T2/T1)<1) then Str1:=Str1+'0'
         else
            begin
              Str1:=Str1+'1';
              T2:=T2-T1;
            end;
      end;
   BinStr:=Str1;
end;

procedure TForm1.FormCreate(Sender: TObject);  {Here is where it starts, read the registry and set everything up}
var
   FTop,FLeft,PM,H2,M1,M2,S1,S2,TStr : string;
begin
   FTop     :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Top','135');
   FLeft    :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Left','280');
   CR1      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CR1','200'));
   CB1      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CB1','1'));
   CG1      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CG1','1'));
   CR2      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CR2','125'));
   CB2      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CB2','1'));
   CG2      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CG2','1'));
   DR1      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DR1','125'));
   DB1      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DB1','0'));
   DG1      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DG1','0'));
   DR2      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DR2','50'));
   DB2      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DB2','0'));
   DG2      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DG2','0'));
   LEDSize  :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','LEDSize','16'));
   IWide    :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','IWide','136'));
   IHigh    :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','IHigh','72'));
   CWide    :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CWide','136'));
   CHigh    :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','CHigh','72'));
   TempStr1  :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Moveable','true');
   TempStr2  :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','UpperDisplay','true');
   TempStr3  :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Colons','true');
   TempStr4  :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Seconds','true');
   TempStr5  :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','PMLite','true');
   Back      :=StrToInt(LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Back','0'));
   PicStr    :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','Picture','');
   DriveStr    :=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DriveStr','');
   DirectoryStr:=LoadStringFromRegistry('Software\PatrickDugan\BinaryClock','DirectoryStr','');
   ClientHeight:=CHigh;
   ClientWidth:=CWide;
   Image1.Height:=IHigh;
   Image1.Width:=IWide;
   LedOnIn :=StringToColor('$00'+IntToHex(CB1,2)+IntToHex(CG1,2)+IntToHex(CR1,2));
   LedOnOut:=StringToColor('$00'+IntToHex(DB1,2)+IntToHex(DG1,2)+IntToHex(DR1,2));
   LedOffIn :=StringToColor('$00'+IntToHex(CB2,2)+IntToHex(CG2,2)+IntToHex(CR2,2));
   LedOffOut:=StringToColor('$00'+IntToHex(DB2,2)+IntToHex(DG2,2)+IntToHex(DR2,2));
   Form1.Top:=StrToInt(FTop);
   Form1.Left:=StrToInt(FLeft);

   If (TempStr2='true') then
      begin
         Panel1.Visible:=true;
         Image1.Top:=16;
         PadY:=17;
      end
   else
      begin
         Panel1.Visible:=false;
         Image1.Top:=0;
         PadY:=0;
      end;

   DrawRoundRectRegion(Form1.Handle, Form1.ClientRect);

   If (Back=2) then
      begin
         MapBackGround;
      end;

   If ((Back=1)and (PicStr<>'')) then
      begin
         try Image1.Picture.LoadFromFile(PicStr);
         except
            on EInvalidGraphic do
               begin
                  ShowMessage('Invalid graphic name.');
               end;
            on EFOpenError do
               begin
                  ShowMessage('Could not open the graphic file requested.');
               end;
         end;
      end;

   DrawRoundRectRegion(Form1.Handle, Form1.ClientRect);

   Blink:=False;
   OldBStr:='00000000000000000000';
   For I := 0 to 4 do
      For J := 0 to 3 do
         begin
            ImageOn[I,J]:=True;
            SwitchLights(I,J);
         end;
   OldPM:='AM';
   SwitchPM;
   FTime:=true;
   Timer1.Enabled:=true;

   If (UpperDisplay) then Image1DblClick(Form1);
   RepaintForm;

end;

procedure TForm1.Timer1Timer(Sender: TObject);  {This is the primary timer to get the time and translate to the leds}
var
    L1,L2,L3,L4,L5,L6                  : string;
    IH2,IM1,IM2,IPM,IS1,IS2            : integer;
    H2,M1,M2,PM,S1,S2,TStr,Comp1,Comp2 : string;
begin
    LongTimeFormat:='h:nn:ss AM/PM';
    TStr:=TimeToStr(Time);
    PM:=Copy(TStr,Length(TStr)-1,2);
    Panel1.Caption:=TStr;
    If (length(TStr)=10) then
       begin
          H2:=Copy(BinStr(StrToInt(Copy(TStr,1,1))),29,4);
          M1:=Copy(BinStr(StrToInt(Copy(TStr,3,1))),29,4);
          M2:=Copy(BinStr(StrToInt(Copy(TStr,4,1))),29,4);
          S1:=Copy(BinStr(StrToInt(Copy(TStr,6,1))),29,4);
          S2:=Copy(BinStr(StrToInt(Copy(TStr,7,1))),29,4);
       end
    else
       begin
          H2:=Copy(BinStr(StrToInt(Copy(TStr,1,2))),29,4);
          M1:=Copy(BinStr(StrToInt(Copy(TStr,4,1))),29,4);
          M2:=Copy(BinStr(StrToInt(Copy(TStr,5,1))),29,4);
          S1:=Copy(BinStr(StrToInt(Copy(TStr,7,1))),29,4);
          S2:=Copy(BinStr(StrToInt(Copy(TStr,8,1))),29,4);
       end;
    BStr:=H2+M1+M2+S1+S2;
    K:=0;
    For I := 0 to 4 do
       For J := 0 to 3 do
          begin
             K:=K+1;
             Comp1:=Copy(OldBStr,K,1);
             Comp2:=Copy(BStr,K,1);
             If (Comp1<>Comp2) then SwitchLights(I,J);
          end;
    OldBStr:=BStr;
    if (OldPM<>PM) then
       begin
          SwitchPM;
       end;
    if (FTime) then
       begin
         RepaintForm;
         FTime:=false;
       end;

end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton; {check for mouse buttons}
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button=mbLeft) then LBDown:=true;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X, {If left mouse down on upper display panel then move form}
  Y: Integer);
var
  NewX,NewY : longint;
  P, Q : TPoint;
begin
   if ((LBDown) and (Moveable)) then
      begin
        P.X := X;                          { P is the TPoint record for the form}
        P.Y := Y;
        Q := ClientToScreen(P);            { Q is the TPoint for the screen }
        NewX:=(Q.X-(Panel1.Width div 2));
        NewY:=(Q.Y-(Panel1.Height div 2));
        If (Form1.Left<0) then Form1.Left:=0
        else Form1.Left:=NewX;
        if (Form1.Top<0) then Form1.Top:=0
        else Form1.Top:=NewY;
      end;
end;

procedure TForm1.FMouseMove(Sender: TObject; Shift: TShiftState; X,  {If left mouse down on form then move form}
  Y: Integer);
var
  NewX,NewY : longint;
  P, Q : TPoint;
begin
   if ((LBDown) and (Moveable)) then
      begin
        P.X := X;                          { P is the TPoint record for the form}
        P.Y := Y;
        Q := ClientToScreen(P);            { Q is the TPoint for the screen }
        NewX:=(Q.X-(Image1.Width - 10));
        NewY:=(Q.Y-(Image1.Height div 2));
        If (Form1.Left<0) then Form1.Left:=0
        else Form1.Left:=NewX;
        if (Form1.Top<0) then Form1.Top:=0
        else Form1.Top:=NewY;
      end;
end;

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton;  {If right mouse button is raised then repaint form}
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button=mbLeft) then  LBDown:=false;
  if (Button=mbRight) then Form3.Visible:=true;
  if ((Back=2) and (Button=mbLeft)) then
     begin
        RepaintForm;
     end;
end;

procedure TForm1.Image1DblClick(Sender: TObject);  {Toggle the upper time display on & off}
begin
   if (UpperDisplay) then
      begin
         if (LedSize<7) then
            begin
               if (Not(Seconds) and Not(PMLite)) then Panel1.Font.Size:=LEDSize -3;
               if (Not(Seconds) and (PMLite))    then Panel1.Font.Size:=LEDSize -2;
               if ((Seconds) and Not(PMLite))    then Panel1.Font.Size:=LEDSize -2;
               if ((Seconds) and (PMLite))       then Panel1.Font.Size:=LEDSize -1;
            end
         else Panel1.Font.Size:=8;
         Panel1.Font.Name:='Unknown';
         Panel1.Visible:=true;
         PadY:=17;
         Form1.Height:=Form1.Height+17;
         DrawRoundRectRegion(Form1.Handle, Form1.ClientRect);
      end
   else
      begin
         Panel1.Visible:=false;
         PadY:=0;
         Form1.Height:=Form1.Height-17;
         DrawRoundRectRegion(Form1.Handle, Form1.ClientRect);
      end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);  {This timer controls the colons that blink}
var
  M,N,NN,MM : integer;
begin
   If not(Blink) then
      begin
          Blink:=true;
          Form1.Image1.Canvas.Pen.Color:=clBlack;
          Form1.Image1.Canvas.Brush.Color:=clBlack;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          For N:=0 to 1 do
             For M:= 1 to 2 do
                begin
                   If (N=1) then NN:=2
                   else NN:=0;
                   case N of
                      0   : Pad:=(LEDSize div 2);
                      1,2 : Pad:=LEDSize;
                   end;
                   Pad:=Pad+round(LEDSize div 12);
                   if ((Seconds) and (N=0)) or ((Seconds) and (N=1) or (not(Seconds) and (N=0))) then
                      if (Colons) then Form1.Image1.Canvas.Ellipse((NN*LEDSize)+1+Pad+(LEDSize),M*LEDSize+1+(LEDSize div 2),(NN*LEDSize)+1+Pad+(LEDSize)+(LEDSize div 4),M*LEDSize+1+(LEDSize div 2)+(LEDSize div 4));
                end;
      end
   else
      begin
          Blink:=false;
          Form1.Image1.Canvas.Pen.Color:=clBlue;
          Form1.Image1.Canvas.Brush.Color:=clBlue;
          Form1.Image1.Canvas.Brush.Style:=bsSolid;
          For N:=0 to 1 do
             For M:= 1 to 2 do
                begin
                   If (N=1) then NN:=2
                   else NN:=0;
                   case N of
                      0   : Pad:=(LEDSize div 2);
                      1,2 : Pad:=LEDSize;
                   end;
                   Pad:=Pad+round(LEDSize div 12);
                   if ((Seconds) and (N=0)) or ((Seconds) and (N=1) or (not(Seconds) and (N=0))) then
                      if (Colons) then Form1.Image1.Canvas.Ellipse((NN*LEDSize)+1+Pad+(LEDSize),M*LEDSize+1+(LEDSize div 2),(NN*LEDSize)+1+Pad+(LEDSize)+(LEDSize div 4),M*LEDSize+1+(LEDSize div 2)+(LEDSize div 4));
                end;
      end;
end;

procedure TForm1.FormDestroy(Sender: TObject);  {write values to registry and exit}
begin
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Top',IntToStr(Form1.Top));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Left',IntToStr(Form1.Left));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CR1',IntToStr(CR1));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CB1',IntToStr(CB1));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CG1',IntToStr(CG1));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CR2',IntToStr(CR2));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CB2',IntToStr(CB2));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CG2',IntToStr(CG2));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DR1',IntToStr(DR1));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DB1',IntToStr(DB1));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DG1',IntToStr(DG1));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DR2',IntToStr(DR2));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DB2',IntToStr(DB2));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DG2',IntToStr(DG2));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','LEDSize',IntToStr(LEDSize));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','IWide',IntToStr(Form1.Image1.Width));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','IHigh',IntToStr(Form1.Image1.Height+17));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CWide',IntToStr(ClientWidth));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','CHigh',IntToStr(ClientHeight+17));
   if (Moveable) then SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Moveable','true')
   else SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Moveable','false');
   if (UpperDisplay) then SaveStringToRegistry('Software\PatrickDugan\BinaryClock','UpperDisplay','true')
   else SaveStringToRegistry('Software\PatrickDugan\BinaryClock','UpperDisplay','false');
   if (Colons) then SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Colons','true')
   else SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Colons','false');
   if (Seconds) then SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Seconds','true')
   else SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Seconds','false');
   if (PMLite) then SaveStringToRegistry('Software\PatrickDugan\BinaryClock','PMLite','true')
   else SaveStringToRegistry('Software\PatrickDugan\BinaryClock','PMLite','false');
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Back',IntToStr(Back));
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','Picture',PicStr);
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DriveStr',DriveStr);
   SaveStringToRegistry('Software\PatrickDugan\BinaryClock','DirectoryStr',DirectoryStr);
end;

end.
